"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.throttled = exports.debounced = exports.cleanup = void 0;
require("core-js/modules/es.function.name.js");
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var cleanup = exports.cleanup = function cleanup() {};

/**
 * Makes methods debounced
 * @param wait
 * @param options
 * @returns
 */
var debounced = exports.debounced = function debounced(wait, options) {
  return function (originalMethod, context) {
    context.addInitializer(function () {
      //@ts-ignore
      this[context.name] = (0, _debounce["default"])(this[context.name], wait, options);
    });
  };
};

/**
 * Makes methods throttled
 * @param wait
 * @param options
 * @returns
 */
var throttled = exports.throttled = function throttled(wait, options) {
  return function (originalMethod, context) {
    context.addInitializer(function () {
      //@ts-ignore
      this[context.name] = (0, _throttle["default"])(this[context.name], wait, options);
    });
  };
};