"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.trace = void 0;
require("core-js/modules/es.function.name.js");
var _proxy = require("../proxy");
var _handler = require("./handler");
var _logger = require("../../logger");
/**
 * Enables logging for invocation detail of the target method.
 * @param targetOrProto The class or prototype that the method belongs to.
 * @param methodName The name of the method.
 */
var _trace = function _trace(originalMethod, context) {
  var methodName = String(context.name);
  if (context.kind === 'method') {
    context.addInitializer(function () {
      var handler = (0, _handler.createLogHandler)((0, _logger.getLogger)('default'));
      this[context.name] = (0, _proxy.proxyMethod)(this[context.name], this, methodName, handler);
    });
  }
};
_trace.to = function (label) {
  var logger = (0, _logger.getLogger)(label);
  return function (originalMethod, context) {
    var methodName = String(context.name);
    if (context.kind === 'method') {
      context.addInitializer(function () {
        var handler = (0, _handler.createLogHandler)(logger);
        this[context.name] = (0, _proxy.proxyMethod)(this[context.name], this, methodName, handler);
      });
    }
  };
};
var trace = exports.trace = _trace;