"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "LogLevel", {
  enumerable: true,
  get: function get() {
    return _type.LogLevel;
  }
});
exports.getLogger = exports.getLogManager = void 0;
Object.defineProperty(exports, "logLevelMap", {
  enumerable: true,
  get: function get() {
    return _constants.logLevelMap;
  }
});
Object.defineProperty(exports, "restoreConsoleHijack", {
  enumerable: true,
  get: function get() {
    return _hijack.restoreConsoleHijack;
  }
});
exports.setLogLevel = void 0;
Object.defineProperty(exports, "setupConsoleHijack", {
  enumerable: true,
  get: function get() {
    return _hijack.setupConsoleHijack;
  }
});
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.map.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/esnext.map.delete-all.js");
require("core-js/modules/esnext.map.emplace.js");
require("core-js/modules/esnext.map.every.js");
require("core-js/modules/esnext.map.filter.js");
require("core-js/modules/esnext.map.find.js");
require("core-js/modules/esnext.map.find-key.js");
require("core-js/modules/esnext.map.includes.js");
require("core-js/modules/esnext.map.key-of.js");
require("core-js/modules/esnext.map.map-keys.js");
require("core-js/modules/esnext.map.map-values.js");
require("core-js/modules/esnext.map.merge.js");
require("core-js/modules/esnext.map.reduce.js");
require("core-js/modules/esnext.map.some.js");
require("core-js/modules/esnext.map.update.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _worker = require("../worker");
var _loggerImpl = require("./logger-impl");
var _managerImpl = require("./manager-impl");
var _type = require("./type");
var _hijack = require("./hijack");
var _constants = require("./constants");
var loggerRegistrar = new Map();
var logLevel = _type.LogLevel.DEBUG;
var getLogger = exports.getLogger = function getLogger() {
  var label = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "default";
  if (!loggerRegistrar.has(label)) {
    loggerRegistrar.set(label, new _loggerImpl.LoggerImpl(label, {
      console: true,
      database: true
    }, logLevel, (0, _worker.getWorkerSingleton)()));
  }
  return loggerRegistrar.get(label);
};
var logManager;
var getLogManager = exports.getLogManager = function getLogManager() {
  if (!logManager) {
    logManager = new _managerImpl.LogManagerImpl((0, _worker.getWorkerSingleton)());
  }
  return logManager;
};
var setLogLevel = exports.setLogLevel = function setLogLevel(_logLevel) {
  logLevel = _logLevel;
  loggerRegistrar.forEach(function (logger) {
    logger.setLogLevel(logLevel);
  });
};