export declare enum LogLevel {
    ERROR = 1,
    WARN = 2,
    INFO = 3,
    DEBUG = 4
}
export interface Logger {
    debug: typeof console.debug;
    info: typeof console.info;
    warn: typeof console.warn;
    error: typeof console.error;
}
export interface LogManager {
    collectLogs(): Promise<File>;
    flush(): Promise<void>;
}
export interface LogWorkerInteractor {
    setMaxRecords(maxRecords: number): Promise<void>;
    sendLog(message: string, label: string): void;
    collectLogs(labels: string[]): Promise<{
        file: File;
        lastId: number;
    }>;
    deleteLogs(labels: string[], lastId: number): Promise<void>;
}
