"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shared = exports.createScheduler = exports.Duration = void 0;
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.weak-set.js");
require("core-js/modules/esnext.weak-set.add-all.js");
require("core-js/modules/esnext.weak-set.delete-all.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _ = require(".");
var _task = require("./task");
var Duration = exports.Duration = /*#__PURE__*/function () {
  function Duration() {
    (0, _classCallCheck2["default"])(this, Duration);
  }
  return (0, _createClass2["default"])(Duration, null, [{
    key: "second",
    value: function second(amount) {
      return this._factors.second * amount;
    }
  }, {
    key: "minute",
    value: function minute(amount) {
      return this._factors.minute * amount;
    }
  }, {
    key: "hour",
    value: function hour(amount) {
      return this._factors.hour * amount;
    }
  }]);
}();
(0, _defineProperty2["default"])(Duration, "_factors", {
  hour: 1000 * 60 * 60,
  minute: 1000 * 60,
  second: 1000
});
var Scheduler = /*#__PURE__*/function () {
  function Scheduler() {
    (0, _classCallCheck2["default"])(this, Scheduler);
    (0, _defineProperty2["default"])(this, "_tasks", new WeakSet());
  }
  return (0, _createClass2["default"])(Scheduler, [{
    key: "addPollingTask",
    value: function addPollingTask(runnable, intervalInMs) {
      var immediate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var onFail = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function () {
        return _.ActionWhenTaskFail.CONTINUE;
      };
      var task = new _task.PollingTask({
        runnable: runnable,
        interval: intervalInMs,
        immediate: immediate,
        onFail: onFail
      });
      task.start();
      this._tasks.add(task);
      return task;
    }
  }, {
    key: "addDelayTask",
    value: function addDelayTask(runnable, delayInMs) {
      var _this = this;
      var task = new _task.PollingTask({
        runnable: runnable,
        interval: delayInMs,
        once: true,
        onFail: function onFail() {
          return _.ActionWhenTaskFail.EXIT;
        },
        onComplete: function onComplete() {
          _this._tasks["delete"](task);
        }
      });
      task.start();
      this._tasks.add(task);
      return task;
    }
  }, {
    key: "addIntervalTask",
    value: function addIntervalTask(runnable, intervalInMs) {
      var immediate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var onFail = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function () {
        return _.ActionWhenTaskFail.CONTINUE;
      };
      var task = new _task.IntervalTask({
        runnable: runnable,
        interval: intervalInMs,
        immediate: immediate,
        onFail: onFail
      });
      task.start();
      this._tasks.add(task);
      return task;
    }
  }]);
}();
var createScheduler = exports.createScheduler = function createScheduler() {
  return new Scheduler();
};
var shared = exports.shared = createScheduler();