export declare enum ActionWhenTaskFail {
    CONTINUE = 0,
    EXIT = 1
}
type AnyFunction = () => void;
type IntervalArguments = {
    runnable: AnyFunction;
    interval: number;
    immediate?: boolean;
    onFail: (err: any) => ActionWhenTaskFail;
    onComplete?: () => void;
};
type PollingArguments = IntervalArguments & {
    once?: boolean;
};
export declare class PollingTask {
    private __arguments;
    private __timer?;
    private __running;
    constructor(__arguments: PollingArguments);
    start(): void;
    private poll;
    stop(): void;
    get isStopped(): boolean;
}
export declare class IntervalTask {
    private __arguments;
    private __timer?;
    private __running;
    constructor(__arguments: IntervalArguments);
    start(): void;
    private poll;
    stop(): void;
    get isStopped(): boolean;
}
export {};
