"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unpersistBinary = exports.persistBinary = exports.getBuffer = exports.clearTempLogs = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _fileReader = require("../../utilities/file-reader");
var _constants = require("../constants");
var _db = require("./db");
var _reply = require("./reply");
var persistBinary = exports.persistBinary = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(self, callId, id, data) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          _context.next = 3;
          return _db.db.tempLogs.put({
            id: id,
            data: data
          });
        case 3:
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.PERSIST_BUFFER, {
            isSuccess: true
          });
          _context.next = 10;
          break;
        case 6:
          _context.prev = 6;
          _context.t0 = _context["catch"](0);
          console.error("[logger] failed to persist buffer.", _context.t0);
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.PERSIST_BUFFER, {
            isSuccess: false
          });
        case 10:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[0, 6]]);
  }));
  return function persistBinary(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();
var unpersistBinary = exports.unpersistBinary = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(self, callId, id) {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          _context2.prev = 0;
          _context2.next = 3;
          return _db.db.tempLogs["delete"](id);
        case 3:
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.UNPERSIST_BUFFER, {
            isSuccess: true
          });
          _context2.next = 10;
          break;
        case 6:
          _context2.prev = 6;
          _context2.t0 = _context2["catch"](0);
          console.error("[logger] failed to unpersist buffer.", _context2.t0);
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.UNPERSIST_BUFFER, {
            isSuccess: false
          });
        case 10:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[0, 6]]);
  }));
  return function unpersistBinary(_x5, _x6, _x7) {
    return _ref2.apply(this, arguments);
  };
}();
var getBuffer = exports.getBuffer = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee3(self, callId, id) {
    var tempLogs, buffer, data;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          _context3.prev = 0;
          _context3.next = 3;
          return _db.db.tempLogs.where("id").equals(id).first();
        case 3:
          tempLogs = _context3.sent;
          if (!(tempLogs !== null && tempLogs !== void 0 && tempLogs.data)) {
            _context3.next = 9;
            break;
          }
          _context3.next = 7;
          return (0, _fileReader.readAsArrayBuffer)(tempLogs.data);
        case 7:
          data = _context3.sent;
          buffer = data;
        case 9:
          if (buffer) {
            (0, _reply.reply)(self, callId, _constants.WorkerDirectives.GET_BUFFER, {
              isSuccess: true,
              buffer: buffer
            }, [buffer]);
          } else {
            (0, _reply.reply)(self, callId, _constants.WorkerDirectives.GET_BUFFER, {
              isSuccess: true,
              buffer: null
            });
          }
          _context3.next = 16;
          break;
        case 12:
          _context3.prev = 12;
          _context3.t0 = _context3["catch"](0);
          console.error("[logger] failed to get buffer.", _context3.t0);
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.GET_BUFFER, {
            isSuccess: false
          });
        case 16:
        case "end":
          return _context3.stop();
      }
    }, _callee3, null, [[0, 12]]);
  }));
  return function getBuffer(_x8, _x9, _x10) {
    return _ref3.apply(this, arguments);
  };
}();
var clearTempLogs = exports.clearTempLogs = /*#__PURE__*/function () {
  var _ref4 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee4(self, callId) {
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          _context4.prev = 0;
          _context4.next = 3;
          return _db.db.tempLogs.clear();
        case 3:
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.CLEAR_TEMP_LOGS, {
            isSuccess: true
          });
          _context4.next = 10;
          break;
        case 6:
          _context4.prev = 6;
          _context4.t0 = _context4["catch"](0);
          console.error("[logger] failed to clear temp logs.", _context4.t0);
          (0, _reply.reply)(self, callId, _constants.WorkerDirectives.CLEAR_TEMP_LOGS, {
            isSuccess: false
          });
        case 10:
        case "end":
          return _context4.stop();
      }
    }, _callee4, null, [[0, 6]]);
  }));
  return function clearTempLogs(_x11, _x12) {
    return _ref4.apply(this, arguments);
  };
}();